/*
 * TemplateJDialog.java
 *
 * Created on 1 octobre 2008, 08:26
 */

package org.cocktail.kiwi.client.nibctrl;

import java.awt.BorderLayout;
import java.util.Vector;

import javax.swing.BorderFactory;
import javax.swing.JScrollPane;
import javax.swing.ListSelectionModel;
import javax.swing.SwingConstants;

import org.cocktail.application.client.swing.TableSorter;
import org.cocktail.application.client.swing.ZEOTable;
import org.cocktail.application.client.swing.ZEOTableModel;
import org.cocktail.application.client.swing.ZEOTableModelColumn;
import org.cocktail.kiwi.client.metier.EOKiwiExportDocuments;
import org.cocktail.kiwi.common.utilities.CocktailConstantes;
import org.cocktail.kiwi.common.utilities.CocktailIcones;

import com.webobjects.eointerface.EODisplayGroup;
import com.webobjects.foundation.NSArray;

/**
 *
 * @author  cpinsard
 */
public class EditionsView extends javax.swing.JDialog {

    	protected EODisplayGroup eod = new EODisplayGroup();
	protected ZEOTable myEOTable;
	protected ZEOTableModel myTableModel;
	protected TableSorter myTableSorter;

    /** Creates new form TemplateJDialog */
    public EditionsView(java.awt.Frame parent, boolean modal, EODisplayGroup displayGroup) {
        super(parent, modal);
        
        eod = displayGroup;
        
        initComponents();
        initGui();
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */

    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        listeMois = new javax.swing.JComboBox();
        listeExercices = new javax.swing.JComboBox();
        jLabel1 = new javax.swing.JLabel();
        buttonClose = new javax.swing.JButton();
        buttonExportXls = new javax.swing.JButton();
        viewTable = new javax.swing.JPanel();
        jScrollPane1 = new javax.swing.JScrollPane();
        consoleSql = new javax.swing.JTextArea();
        buttonSaveSql = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("PAF - Gestion Budgétaire et comptable");

        listeMois.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Item 1", "Item 2", "Item 3", "Item 4" }));
        listeMois.setFocusable(false);
        listeMois.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                listeMoisActionPerformed(evt);
            }
        });

        listeExercices.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Item 1", "Item 2", "Item 3", "Item 4" }));

        jLabel1.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        jLabel1.setText("Période : ");

        buttonClose.setText("Fermer");
        buttonClose.setToolTipText("Fermer la fenêtre");
        buttonClose.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                buttonCloseActionPerformed(evt);
            }
        });

        buttonExportXls.setText("Exporter");
        buttonExportXls.setToolTipText("Exproter au format Excel");

        viewTable.setLayout(new java.awt.BorderLayout());

        consoleSql.setBackground(new java.awt.Color(204, 255, 204));
        consoleSql.setColumns(20);
        consoleSql.setRows(5);
        jScrollPane1.setViewportView(consoleSql);

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(jLabel1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 55, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(listeMois, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 156, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(listeExercices, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 77, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .add(550, 550, 550))
            .add(org.jdesktop.layout.GroupLayout.TRAILING, layout.createSequentialGroup()
                .addContainerGap(656, Short.MAX_VALUE)
                .add(buttonExportXls, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 111, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(buttonClose, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 103, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
            .add(layout.createSequentialGroup()
                .add(20, 20, 20)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(layout.createSequentialGroup()
                        .add(viewTable, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 856, Short.MAX_VALUE)
                        .addContainerGap())
                    .add(layout.createSequentialGroup()
                        .add(jScrollPane1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 820, Short.MAX_VALUE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(buttonSaveSql, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 27, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .add(13, 13, 13))))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.CENTER)
                    .add(jLabel1)
                    .add(listeMois, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(listeExercices, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .add(18, 18, 18)
                .add(viewTable, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 173, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .add(4, 4, 4)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(jScrollPane1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 270, Short.MAX_VALUE)
                    .add(buttonSaveSql, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 26, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(buttonClose)
                    .add(buttonExportXls))
                .addContainerGap())
        );

        java.awt.Dimension screenSize = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
        setBounds((screenSize.width-902)/2, (screenSize.height-574)/2, 902, 574);
    }// </editor-fold>//GEN-END:initComponents

private void listeMoisActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_listeMoisActionPerformed
// TODO add your handling code here:
}//GEN-LAST:event_listeMoisActionPerformed

private void buttonCloseActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buttonCloseActionPerformed

    dispose();

}//GEN-LAST:event_buttonCloseActionPerformed

    /**
    * @param args the command line arguments
    */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                EditionsView dialog = new EditionsView(new javax.swing.JFrame(), true, null);
                dialog.addWindowListener(new java.awt.event.WindowAdapter() {
                    public void windowClosing(java.awt.event.WindowEvent e) {
                        System.exit(0);
                    }
                });
                dialog.setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton buttonClose;
    private javax.swing.JButton buttonExportXls;
    private javax.swing.JButton buttonSaveSql;
    private javax.swing.JTextArea consoleSql;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JScrollPane jScrollPane1;
    protected javax.swing.JComboBox listeExercices;
    protected javax.swing.JComboBox listeMois;
    private javax.swing.JPanel viewTable;
    // End of variables declaration//GEN-END:variables
        
    public void setListeExercices(NSArray exercices) {

        listeExercices.removeAllItems();
        for (int i=0;i<exercices.count();i++)
        	listeExercices.addItem(exercices.objectAtIndex(i));
    }

    public void setSelectedExercice(Object exercice) {
        listeExercices.setSelectedItem(exercice);
    }
    
    
    
    public javax.swing.JButton getButtonExportXls() {
		return buttonExportXls;
	}

	public void setButtonExportXls(javax.swing.JButton buttonExportXls) {
		this.buttonExportXls = buttonExportXls;
	}

	
	
	public ZEOTable getMyEOTable() {
		return myEOTable;
	}

	public void setMyEOTable(ZEOTable myEOTable) {
		this.myEOTable = myEOTable;
	}

	/**
     * 
     * @param liste
     */
    public void setListeMois(String[] liste) {
        
        listeMois.removeAllItems();
        for (int i=0;i<liste.length;i++)
        	listeMois.addItem(liste[i]);    	
    	
    }

        public javax.swing.JComboBox getListeExercices() {
		return listeExercices;
	}

	public void setListeExercices(javax.swing.JComboBox listeExercices) {
		this.listeExercices = listeExercices;
	}
	
	
	public javax.swing.JButton getButtonSaveSql() {
		return buttonSaveSql;
	}

	public void setButtonSaveSql(javax.swing.JButton buttonSaveSql) {
		this.buttonSaveSql = buttonSaveSql;
	}

	public javax.swing.JTextArea getConsoleSql() {
		return consoleSql;
	}

	public void setConsoleSql(javax.swing.JTextArea consoleSql) {
		this.consoleSql = consoleSql;
	}

	public javax.swing.JComboBox getListeMois() {
		return listeMois;
	}

	public void setListeMois(javax.swing.JComboBox listeMois) {
		this.listeMois = listeMois;
	}


	public javax.swing.JButton getButtonPrintExportPapaye() {
		return buttonExportXls;
	}

	public void setButtonPrintExportPapaye(
			javax.swing.JButton buttonPrintExportPapaye) {
		this.buttonExportXls = buttonPrintExportPapaye;
	}

	/**
	 * 
	 */
    private void initGui() {
        
        buttonClose.setIcon(CocktailIcones.ICON_CLOSE);
        buttonExportXls.setIcon(CocktailIcones.ICON_EXCEL);   
        
         Vector myCols = new Vector();
		
		ZEOTableModelColumn col = new ZEOTableModelColumn(eod, EOKiwiExportDocuments.KED_TYPE_KEY, "Type", 100);
		col.setAlignment(SwingConstants.LEFT);
		myCols.add(col);
		col = new ZEOTableModelColumn(eod, EOKiwiExportDocuments.KED_COMMENTAIRE_KEY, "Document à exporter", 500);
		col.setAlignment(SwingConstants.LEFT);
		myCols.add(col);
		col = new ZEOTableModelColumn(eod, EOKiwiExportDocuments.KED_TEMPLATE_KEY, "Template XLS", 100);
		col.setAlignment(SwingConstants.LEFT);
		myCols.add(col);
		
		myTableModel = new ZEOTableModel(eod, myCols);
		myTableSorter = new TableSorter(myTableModel);

		myEOTable = new ZEOTable(myTableSorter);
		//myEOTable.addListener(myListenerContrat);
		myTableSorter.setTableHeader(myEOTable.getTableHeader());		

		myEOTable.setBackground(CocktailConstantes.COLOR_FOND_NOMENCLATURES);
		myEOTable.setSelectionBackground(CocktailConstantes.COLOR_SELECTED_ROW);
		myEOTable.setSelectionMode(ListSelectionModel.MULTIPLE_INTERVAL_SELECTION);
		
		viewTable.setLayout(new BorderLayout());
		viewTable.setBorder(BorderFactory.createEmptyBorder(2,2,2,2));
		viewTable.removeAll();
		viewTable.add(new JScrollPane(myEOTable), BorderLayout.CENTER);

        
    }
}
